#define SAVE_SCREEN
#define USE_LONGMUL_PATCH

#include <nostub.h>
#include <kbd.h>
#include <graph.h>
#include <system.h>
#include <statline.h>
#include <stdio.h>
#include <stdlib.h>

int _ti89;

#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define SECOND_KEY 16
#define ESC_ROW 0xffbf
#define ESC_KEY 1


void PutSprite16 (int x, int y, int h, int *sprite, void *buff)
{
  register long addr = (long)buff + 30*y + ((x>>3) & 0xFFFE);
  register int i, cnt = 16 - (x&15);
  for (i = 0; i < h; addr += 30) *(long*)addr ^= (long)(unsigned)sprite[i++] << cnt;
}

void end(int score,int *highscore,char *initials)
{

int count,key=0,x=0,counter;
		clrscr();
		printf("%|26s","Game Over");
		printf("\n\nYour score is %d.",score);
		if(score<=*highscore)
			printf("\nHighscore is %d by %s",*highscore,initials);
			
		if(score>*highscore)
		{
			printf("\nOld High Score was %d",*highscore);
			*highscore=score;
			printf("\nNew High Score of %d!",score);
			
			printf("\nEnter your initials.\n");
			for(count=0;count<=2;count++)
			{
				GKeyFlush();
				while(key==0)
				{
					GKeyFlush();
					key=GKeyIn(NULL,0);
					ST_busy(ST_IDLE);
				}
				printf("%c",key);
				initials[count]=key;
				if(key==257)
				{
					printf("\n");
					for(counter=0;counter<count-1;counter++)
						printf("%c",initials[counter]);
					count-=2;
				}	
				key=0;
			}
		}
		GKeyFlush();
		while(GKeyIn(NULL,0)!=13);
			GKeyFlush();
		clrscr();
}
int move_ball(int x,int y,int which,int how_many)
{
 int  ball[16] = { 0x0000,
 0x0000,
 0x0000,
 0x0000,
 0x03C0,
 0x07E0,
 0x0FF0,
 0x0FF0,
 0x0FF0,
 0x0FF0,
 0x07E0,
 0x03C0,
 0x0000,
 0x0000,
 0x0000,
 0x0};

pICON *ball_pt=&ball[0];
if(which==1)
{
	PutSprite16(x,y,16,ball_pt,LCD_MEM);
	return y;
}
		DrawIcon(x,y,ball_pt,A_XOR);
		y+=how_many;
		PutSprite16(x,y,16,ball_pt,LCD_MEM);
		return y;
        	
}
int move_ship(int x,int y,int what,int how_many)
{
int key=0;
 int ship[16] = { 0x0180,
 0x03C0,
 0x07E0,
 0x0FF0,
 0x1FF8,
 0x3FFC,
 0x7FFE,
 0xFFFF,
 0x0000,
 0x0000,
 0x0000,
 0x0000,
 0x0000,
 0x0000,
 0x0000,
 0x0};
pICON *ship_pt=&ship[0];

if(what==1)
{
	PutSprite16(x,y,16,ship_pt,LCD_MEM);
	return x;
}

	ST_busy(ST_IDLE);

		key=_rowread(ARROWS_ROW);
		{
			DrawIcon(x,y,ship_pt,A_XOR);
			x+=(((x<142)&&(key&RIGHT_KEY))-((x>2)&&(key&LEFT_KEY)))*how_many;
			PutSprite16(x,y,16,ship_pt,LCD_MEM);
			if(key&SECOND_KEY)
				off();
		}
	return x;
}
		
int engine(int num_of_balls,int *ball_x,int *ball_y,int *ship_x,int *score,int *highscore,char *initials)
{
int ball_num,count,counter;
char bar[50];

for(counter=1;counter<=10;counter++)
{
        ball_num=0;
	ball_y[0]=-4;
	ball_x[0]=*ship_x;
	move_ball(ball_x[0],ball_y[0],1,num_of_balls);
	for(count=1;count<=num_of_balls-1;count++)
	{
        	ball_y[count]=-4;
		ball_x[count]=random(148);
		move_ball(ball_x[count],ball_y[count],1,num_of_balls);
	}    
	pushkey(13);

for(count=0;count<=88;count+=num_of_balls)
{

for(ball_num=0;ball_num<=num_of_balls-1;ball_num++)
{
	if((ball_x[ball_num]+12>=(*ship_x)+4 && ball_x[ball_num]+4<=(*ship_x)+12) && (ball_y[ball_num]+12>=84 && ball_y[ball_num]+8<=84+8))
	{
	
		end(*score,highscore,initials);
		return 1;
	}
	ball_y[ball_num]=move_ball(ball_x[ball_num],ball_y[ball_num],0,num_of_balls);
}

		*ship_x=move_ship(*ship_x,84,0,num_of_balls);
                if(_rowread(ESC_ROW)&ESC_KEY)
                {
			end(*score,highscore,initials);
			return 1;
		}
	
		


        
}
	(*score)+=num_of_balls*10;
	ClrScr();
	move_ship(*ship_x,84,1,2);
		sprintf(bar,"Score: %d Highscore: %d by %s",*score,*highscore,initials);
		ST_helpMsg(bar);
}
return 0;
}
void game(int does)
{
int ball_x[10]={0,0,0,0,0,0,0,0,0,0};
int ball_y[10]={-4,-4,-4,-4,-4,-4,-4,-4,-4,-4};
int ship_x=72,ship_y=84,count=0,score=0,ball_num=0,counter=0,num_of_balls;
int movement=0;
static int highscore=0;
static char initials[3]="   ";
char bar[50];

if(does==1)
{
	clrscr();
	printf("\n\n\nHighscore:\n%d   %s",highscore,initials);
	GKeyFlush();
	GKeyIn(NULL,0);
	return;
}

	ClrScr();
        move_ship(ship_x,ship_y,1,1);
		sprintf(bar,"Score: %d Highscore: %d by %s",score,highscore,initials);
		ST_helpMsg(bar);
for(counter=1;counter<=10;counter++)
{
  ball_y[0]=-4;
	ball_x[0]=ship_x;
	move_ball(ball_x[ball_num],ball_y[ball_num],1,1);
	pushkey(13);

for(count=0;count<=88;count+=1)
{

	if((ball_x[ball_num]+12>=ship_x+4 && ball_x[ball_num]+4<=ship_x+12) && (ball_y[ball_num]+12>=ship_y && ball_y[ball_num]+8<=ship_y+8))
	{
	
		end(score,&highscore,&initials[0]);
		return;
	}

		ship_x=move_ship(ship_x,ship_y,0,1);
                if(_rowread(ESC_ROW)&ESC_KEY)
                {
			end(score,&highscore,&initials[0]);
			return;
		}
	ball_y[ball_num]=move_ball(ball_x[ball_num],ball_y[ball_num],0,1);
		


        
}
	score+=10;
	ClrScr();
	move_ship(ship_x,ship_y,1,1);
		sprintf(bar,"Score: %d Highscore: %d by %s",score,highscore,initials);
		ST_helpMsg(bar);
}


//----------------------------------------;
//2+ balls;
for(num_of_balls=2;num_of_balls<=500;num_of_balls++)
{
	if(1==engine(num_of_balls,&ball_x[0],&ball_y[0],&ship_x,&score,&highscore,&initials[0]))
		return;
}
end(score,&highscore,&initials[0]);
}

void _main(void)
{
int key=0;

while(1)
{
clrscr();
printf_xy(56,25,"1. Start");
printf_xy(41,35,"2. High Score");
printf_xy(35,45,"3. Instructions");
printf_xy(53,55,"4. About");
printf_xy(59,65,"5. Exit");
key=0;
GKeyFlush();
key=GKeyIn(NULL,0);
if(key==50)	//2
{
	game(1);
}
if(key==51)	//3
{
	clrscr();
	printf("Esc - exits the game or \nreturns to main menu.\n\nArrow Keys - move ship \naround");
	printf("\n\n2nd - pauses game and \nturns off calculator %c",13);
	GKeyFlush();
	GKeyIn(NULL,0);
	printf("\n\n\nThe object of the game is to avoid being hit by the oncoming balls.");
	GKeyFlush();
	GKeyIn(NULL,0);
}
if(key==52)	//4
{
	clrscr();
	printf("\nDodge-Em's v2.0\nby Josh Hill\n\nProgrammers Anonymous \nMember\nhttp://pa.ticalc.org");
	GKeyFlush();
	GKeyIn(NULL,0);
}
if(key==53 || key==264)	//5
	return;
if(key==49)
game(0);
}
}
